string cvs_version= "$Id: simplenews.pike,v 2.7 1999/08/27 04:35:58 redhat Exp $";

inherit "roxenlib";
inherit "http";
inherit "module";
#include <module.h>
#include <stdio.h>

int calls;
int edit;
int nr;
int art;
int dayz;

array register_module()
{
//*** RETURN TAGS TYPE
  return ({ MODULE_PARSER|MODULE_LOCATION, "SimpleNews v2.7",
              "This module can be used if you want to setup a simple news feature for your front page."});

}

class article
{
   int date;
   int nr;
   
   string title  = "Unknown";
   string body   = "Unknown";
   string author = "Unknown";
   string keyword= "";

   string whole()
   {
     return "<DIV valign=center>\n<CENTER>\n<H2>\n"+ title +"</H2>/n</CENTER>/n</DIV>/n<B>"+
             body +"<DIV align=right>\n<I>-- "+ author +"</I>\n"+
	    "&nbsp;&nbsp;&nbsp;\n</DIV>\n</B><BR>"+ ctime(date) +"\n<HR size=2>\n";
   }

   void selfdestruct()
   {
     destruct(this_object);
   }

   object link;  // links to last similar article (based on keywords)
   
   object next;
   object last;

   int crc()
   {
    if(crcval == hash(sprintf("%O",this_object)))
      return 1;
    crcval = hash(sprintf("%O",this_object));
    return 0;
   }
   int crcval = hash(sprintf("%O",this_object));
}

mapping(string:object) keywords;
mapping(string:object) news;

void create()
{
  defvar("dir",
         "../logs/",
         "SimpleNews Directory",
          TYPE_DIR,
         "Directory you store the *.snf files.");
  defvar("size",
          3,
         "Amount of Articles",
          TYPE_INT,
         "Amount of articles displayed with &lt;news&gt;.");
  defvar("hsize",
          3,
         "Amount of Headers",
          TYPE_INT,
         "Amount of headers displayed with &lt;hnews&gt;.");
  defvar("mnt",
         "/simplenews/",
         "Mountpoint",
          TYPE_LOCATION,
         ".");
  defvar("body",
         "<BODY>",
         "BODY",
          TYPE_STRING,
         "Standaard &lt;BODY&gt; tag, used in simplenews directory.");
}

string status()
{
  return
    (
     "<h1>Hosts statistics</h1>" +
     "<b>News Reads:</b> "+(string)calls+"<br>\n"
     "<b>News Edits:</b> "+(string)edit+"<br>\n"
    );
}

array read_articles()
{
}

void stop()
{
}

void start(int mode, object configuration)
{
  dayz = localtime(time())["yday"];
}

string tag_addnews(string t, mapping m, mixed id)
{
  string ReturnResults;
  if(dayz!=localtime(time())["yday"]) nr=0;
  nr++;

  
  if(sprintf("%O",id->variables)!="([ ])")
  {
    // if(id->method == "GET") return "Error: GET methode was used instead of POST....";
     ReturnResults = "<DIV valign=center>\n<CENTER>\n<H2>\n"+ id->variables["title"] +"</H2>\n</CENTER>\n</DIV>\n<B>"+
	              replace(id->variables["body"],({"","","","","","","","","","","","","/n",""}),({"pike",
		                                                                                      "Pike","PIke","PiKe","PikE",
												      "pIke","pIKe","pIKe","pIkE",
												      "piKe","piKE","pikE","%21","\r"}))
		     +"<DIV align=right>\n<I>-- "+ id->variables["author"] +"</I>\n"+
                     "&nbsp;&nbsp;&nbsp;\n<BR>"+ ctime(time()) +"\n<HR size=2></DIV>\n</B>\n";
     /*
     news_articles[]->last->body = ;
     news_articles[]->last->title = ;
     news_articles[]->last->author = ;
     news_articles[]->last = ;
     ReturnResults = "New News Added";
     */
     Stdio.write_file(query("dir")+(string)time()+(string)nr+".snf",ReturnResults);
     Stdio.write_file(query("dir")+"simplenewsfiles.snf","["+ (string)time()+(string)nr +"]#["+ id->variables["title"] +"]#\n");
     ReturnResults = "<H2>New News Added</H2><HR>" + ReturnResults;
  }
  else
  {
     ReturnResults =  "<FORM METHODE=POST>"; // ACTION="+id->not_query+">";
     ReturnResults += "Title:<BR>";
     ReturnResults += "<INPUT type=textbox name=title value=Title><BR>";
     ReturnResults += "Body:<BR>";
     ReturnResults += "<TEXTAREA name=body rows=30 cols=90></TEXTAREA><BR>";
     ReturnResults += "Your Name:<BR>";
     ReturnResults += "<INPUT type=textbox name=author value=YourName><BR>";
     ReturnResults += "<INPUT type=submit name=SUBMIT>";
     ReturnResults += "";
     ReturnResults += "</FORM>";
  }
  return ReturnResults;
}

string tag_hnews(string t, mapping m, mixed id)
{
  string file = Stdio.read_file(query("dir") +"simplenewsfiles.snf");
  string revfile = reverse(file);
  string temp, tmptitle, tmplink;
  string ReturnResults = "";
  int size;

  for(size = query("hsize"); size > 0; size--)
  {
    catch(sscanf(revfile,"%*s]%s[#]%s[%s", tmptitle, tmplink, temp));
    if(tmptitle=="") break;
    revfile=temp;
    ReturnResults += "<A HREF="+ query("mnt") +"?"+ reverse(tmplink) +">"+ reverse(tmptitle) +"</A><BR>";
    if(temp=="") break;
  }
  return ReturnResults;
}

string tag_news(string t, mapping m, mixed id)
{
  string file = Stdio.read_file(query("dir") +"simplenewsfiles.snf");
  string revfile = reverse(file);
  string temp, tmplink;
  string ReturnResults = "";
  int size;

  for(size = query("size"); size > 0; size--)
  {
    catch (sscanf(revfile,"%*s]%*s[#]%s[%s", tmplink, temp));
    if(tmplink=="") break;
    revfile=temp;
    ReturnResults += Stdio.read_file(query("dir") + reverse(tmplink) +".snf");
    if(temp=="") break;
  }
  return ReturnResults;
}

string query_location()
{
  return QUERY(mnt);
}

string query_name()
{
  return sprintf("SimpleNews using <i>%s</i>", query("mnt"));
}

mixed find_file(string t, object id)
{
  return http_string_answer("<HTML><HEAD><TITLE>"+id->query
                           +"</TITLE></HEAD>"+query("body")+
			   Stdio.read_file(query("dir")+id->query+".snf"));
}

mapping query_tag_callers()
{
  return ([ "news":tag_news,
	    "hnews":tag_hnews,
	    "addnews":tag_addnews,
           ]);
}

/****** SAVED STUFF:

return (string) localtime(time())["yday"] +"<BR>"+ (string) localtime(time() +  86400)["yday"];
*/
